//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ColorCovered0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}

const int RED=2, GREEN=1, BLUE=0;

void assignColor(TImage *image, int idxColor)
{ Byte * ptr;
  int index;
  unsigned char red, green, blue;

  switch (idxColor)
    { case 2 : // blue-case
               red=  0;  green=  0;  blue=255;  break;
      case 1 : // green-case
               red=  0;  green=255;  blue=  0;   break;
      default: // red-case@
               red=255;  green=  0;  blue=  0;
    }
  image->Picture->Bitmap->PixelFormat = pf24bit;
  for (int row=0; row<image->Picture->Height; row++)
     { ptr = (Byte *) image->Picture->Bitmap->ScanLine[row];
       index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { ptr[index+RED]  &= red;
            ptr[index+GREEN]&= green;
            ptr[index+BLUE] &= blue;

            index += 3;
          }
     }
  image->Refresh();
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Image2->Picture->Assign(Image1->Picture);
  //Image2->Picture->Bitmap->Canvas->Font->Color = clRed;
  //Image2->Picture->Bitmap->Canvas->TextOutA(10,10,"");
  Image2->AutoSize = true;
  ShowMessage("Waiting");

  int color = ComboBox1->ItemIndex; // (red, green, blue) = (0, 1, 2);
  assignColor(Image2, color);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  JpgToBmp(Image2);
}
//---------------------------------------------------------------------------

